About
-----
A generic [treemap][] user interface component for web applications written in [Dart][].

Features
--------
- Highly customizable through a exentsible data model
- Supports live updates and user interaction 
- Includes several common layout algorithms
    - Slice-And-Dice
    - Strip
    - Squarified
    - Split
    - Pivot-by-Size
    - Pivot-by-Middle

Usage
-----
- [Basic example](https://github.com/usommerl/treemap_ui/blob/master/doc/basic_example.md)
- [Custom model example](https://github.com/usommerl/treemap_ui/blob/master/doc/custom_model_example.md)
- [API Documentation][]

Install bleeding edge version
-----------------------------

Add this to your `pubspec.yaml`:

```yaml
dependencies:
  treemap_ui:
    git: git@github.com:usommerl/treemap_ui.git
```

Then run the package manager [pub][]:

    pub install

Collaboration
-------------
Patches and pull requests are welcome. Please file issues in our [issue tracker][].

License
-------
Licensed under the Apache License, Version 2.0


[issue tracker]: https://github.com/usommerl/treemap_ui/issues
[treemap]: http://en.wikipedia.org/wiki/Treemapping
[TreemapUI]: https://github.com/usommerl/treemap_ui/
[Dart]: http://www.dartlang.org/
[pub]: http://www.dartlang.org/docs/pub-package-manager/
[API Documentation]: https://googledrive.com/host/0B7SuAtTI9WeHZk1tMkFDbHRpUk0/
